( function( $ ) {

    $(document).ready(function() {
        $('#capabilitySelector').select2({
        });
    });

    $(document).on('keydown','.dd-new-role', function(e) {
        if (e.key === 'Enter') {
            e.preventDefault();
            $('.js-newRole').click();
            return false;
        }
    });
    $(document).on('keydown','.dd-new-capability', function(e) {
        if (e.key === 'Enter') {
            e.preventDefault();
            $('.js-newCapability').click();
            return false;
        }
    });
    $(document).on('focus','.dd-new-role', function(e) {
        $('.settings-error').fadeOut('fast', function(){
            $(this).addClass('hidden').attr('style', '');
        });
    });

    $(document).on('click','.js-newRole', function(){
        var newRoleName = $('.dd-new-role').val();
        if(newRoleName === ''){
            showError();
        }
        else{
            var data = {
                action: 'verify_and_add',
                new_role_display_name: newRoleName
            };
            $.post(ajaxurl, data, function(unique) {
                parseInt(unique) ? location.reload() : showError();
            });
        }
    });

    $(document).on('click','.js-newCapability', function(){
        var newCapability = $('.dd-new-capability').val();
        if(newCapability === ''){
            showError();
        }
        else{
            var data = {
                action: 'create_capability',
                new_capability: newCapability
            };
            $.post(ajaxurl, data, function(capability) {
                capability ? location.reload() : showError();
            });
        }
    });


    function showError(){
        $('.duplicated').removeClass('hidden');
    }

    $(document).on('click', '.js-migrate', function(){
        var fromRole =  $('.fromRole').val();
        var toRole =  $('.toRole').val();

        var data = {
            action: 'migrateUsers',
            fromRole: fromRole,
            toRole: toRole
        };
        $.post(ajaxurl, data, function(migrated) {
            location.reload();
        });
    });

    $(document).on('change', '.capLabel.active', function () {
        var thisCapLabel = $(this),
            firstRow = thisCapLabel.parents('.roleRow').prev('.roleRow'),
            state = thisCapLabel.children('input').is(':checked'),
            capName = thisCapLabel.children('input').val(),
            role_id = firstRow.find('.role_id').val(),
            data = {
                action: 'changeCapState',
                state: state,
                capName: capName,
                role_id : role_id
            };

        thisCapLabel.addClass('loading').find('.spinner').addClass('is-active');
        $.post(ajaxurl, data, function(roleCapCounters) {
            roleCapCounters = JSON.parse(roleCapCounters);
            thisCapLabel.removeClass('loading').find('.spinner').removeClass('is-active');
            firstRow.find('.progress-bar').css("width", roleCapCounters['percent']);
            firstRow.find('.progressCount').val(roleCapCounters['totalRoleActiveCapabilities']);
            firstRow.find('.sr-only').text( roleCapCounters['percent']+' Capabilities');
        });
    });


    $(document).on('click','.js-openInfo', function(e){
        e.preventDefault();
        var thisRow = $(this).parents('.roleRow');
        var infoBlock = thisRow.next('.capabilitiesRow');
        var editText = thisRow.find('.js-collapseLink');
        var currentName = editText.text();
        var newName = editText.data("othertext");

        editText.toggleClass('open').text(newName).data('othertext',currentName);
        infoBlock.toggleClass('hidden');
    });

    $(document).on('click','.deleteRole', function(e){
        e.preventDefault();
        var role_id = $(this).parents('.roleRow').find('.role_id').val();
        var data = {
            action: 'deleteRole',
            role_id: role_id
        };
        $.post(ajaxurl, data, function(roleDeleted) {
            location.reload();
        });
    });

    $(document).on('click','.js-cleanUp', function(e){
        e.preventDefault();

        var delcaps = $('.deleteCap').val();

        var data = {
            action: 'cleanUp',
            delcaps: delcaps
        };
        $.post(ajaxurl, data, function(capDeleted) {
            setInterval(location.reload(),5000);
        });
    })

} )( jQuery );



